package com.chuanglan.shanyan_sdk_test_demo;

import android.app.Application;
import android.content.Context;
import android.util.Log;

import com.chuanglan.shanyan_sdk.OneKeyLoginManager;
import com.chuanglan.shanyan_sdk.listener.InitListener;
import com.chuanglan.shanyan_sdk_test_demo.utils.BuglyUtils;


public class MyApplication extends Application {


    @Override
    public void onCreate() {
        super.onCreate();

        //闪验SDK配置debug开关 （必须放在初始化之前，开启后可打印闪验SDK更加详细日志信息）
        OneKeyLoginManager.getInstance().setDebug(true);

        //闪验SDK初始化（建议放在Application的onCreate方法中执行）
        initShanyanSDK(getApplicationContext());

        //闪验demo示例崩溃信息日志收集，开发者不需要添加
        BuglyUtils.setBugly(getApplicationContext());

        //闪验demo示例内存泄漏检测，开发者不需要添加
        //LeakCanaryUtils.setupLeakCanary(getApplicationContext());

    }

    private void initShanyanSDK(Context context) {
        OneKeyLoginManager.getInstance().init(context, BuildConfig.APP_ID, new InitListener() {
            @Override
            public void getInitStatus(int code, String result) {
                //闪验SDK初始化结果回调
                Log.e("VVV", "初始化： code==" + code + "   result==" + result);
            }
        });
    }


}
