package com.chuanglan.shanyan_sdk_test_demo.http;


import com.chuanglan.shanyan_sdk_test_demo.BuildConfig;

import java.util.Map;

import okhttp3.ResponseBody;
import retrofit2.Call;
import retrofit2.Retrofit;

public class RequestExample {

    public AuthenticationRequestApi getService() {
        //创建Retrofit对象
        Retrofit retrofit = new Retrofit.Builder()
                .baseUrl(BuildConfig.SERVER_URL)
                .build();

        //创建网络请求接口实例
        AuthenticationRequestApi service = retrofit.create(AuthenticationRequestApi.class);
        return service;
    }

    /**
     * 获取手机号
     *
     * @param appId
     * @param accessToken
     * @param telecom
     * @param timestamp
     * @param randoms
     * @param sign
     * @return
     */
    public Call<ResponseBody> getPhoneCode(String appId, String accessToken, String telecom, String timestamp, String randoms, String sign, String version, String device) {
        Call<ResponseBody> service = null;
        Map<String, String> params = NetParams.getInstance().oneKeyLogin(appId, accessToken, telecom, timestamp, randoms, sign, version, device);
        if (telecom.equals("CMCC")) {//移动
            service = getService().getMobile01(params);
        } else if (telecom.equals("CUCC")) {//联通
            service = getService().getMobile02(params);
        } else if (telecom.equals("CTCC")) {//电信
            service = getService().getMobile03(params);
        }
        return service;
    }


    public Call<ResponseBody> getOneKeyLoginMobile(String appId, String tokenData, String sign) {
        Call<ResponseBody> service = null;
        Map<String, String> params = NetParams.getInstance().oneKeyLoginMobile(appId, tokenData, sign);
        service = getService().getMobile(params);
        return service;
    }

    public Call<ResponseBody> getMobileValidate(String appId, String tokenData, String mobile, String sign) {
        Call<ResponseBody> service = null;
        Map<String, String> params = NetParams.getInstance().mobileValidate(appId, tokenData, mobile, sign);
        service = getService().authentication(params);
        return service;
    }
}
