package com.chuanglan.shanyan_sdk_test_demo.view;

import android.annotation.TargetApi;
import android.app.Activity;
import android.content.ClipData;
import android.content.Intent;
import android.net.Uri;
import android.os.Build;
import android.os.Bundle;
import android.text.TextUtils;
import android.util.Log;
import android.view.View;
import android.webkit.ValueCallback;
import android.webkit.WebChromeClient;
import android.webkit.WebSettings;
import android.webkit.WebView;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.RelativeLayout;
import android.widget.TextView;

import com.bumptech.glide.Glide;
import com.chuanglan.shanyan_sdk.OneKeyLoginManager;
import com.chuanglan.shanyan_sdk.listener.GetPhoneInfoListener;
import com.chuanglan.shanyan_sdk_test_demo.BuildConfig;
import com.chuanglan.shanyan_sdk_test_demo.R;
import com.chuanglan.shanyan_sdk_test_demo.http.RequestExample;
import com.chuanglan.shanyan_sdk_test_demo.utils.AESUtils;
import com.chuanglan.shanyan_sdk_test_demo.utils.SignUtils;

import org.json.JSONObject;

import java.util.HashMap;
import java.util.Map;

import okhttp3.ResponseBody;
import retrofit2.Call;
import retrofit2.Callback;
import retrofit2.Response;

public class ResultActivity extends Activity implements View.OnClickListener {

    private final static int FILE_CHOOSER_RESULT_CODE = 10000;
    private ImageView image_result;
    private long time;
    private RequestExample example = new RequestExample();
    private String result;
    private int code;
    private TextView result_phone, result_telecom, errorText, login_success;
    private RelativeLayout try_again;
    private LinearLayout authenticationresult_success, authenticationresult_fail;
    private WebView mWebView;
    private RelativeLayout online_customer, online_call;
    private ValueCallback<Uri> uploadMessage;
    private ValueCallback<Uri[]> uploadMessageAboveL;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        OneKeyLoginManager.getInstance().finishAuthActivity();
        setContentView(R.layout.activity_result);
        initViews();
        initEvent();
        /************重新预取号，建议放到退出登录事件里面，缩短下次拉起授权页的时间***************/
        //闪验SDK预取号（可缩短拉起授权页时间）
        OneKeyLoginManager.getInstance().getPhoneInfo(new GetPhoneInfoListener() {
            @Override
            public void getPhoneInfoStatus(int code, String result) {
                //预取号回调
                Log.e("VVV", "预取号： code==" + code + "   result==" + result);
            }
        });
    }

    private void initViews() {
        image_result = findViewById(R.id.image_result);
        result_phone = findViewById(R.id.result_phone);
        result_telecom = findViewById(R.id.result_telecom);
        login_success = findViewById(R.id.login_success);
        login_success.setText("登录中...");
        try_again = findViewById(R.id.try_again);
        authenticationresult_success = findViewById(R.id.authenticationresult_success);
        authenticationresult_fail = findViewById(R.id.authenticationresult_fail);
        errorText = findViewById(R.id.authentication_errorText);
        mWebView = findViewById(R.id.baseweb_webview);
        online_customer = findViewById(R.id.online_customer);
        online_call = findViewById(R.id.online_call);
        Glide.with(this).load(R.mipmap.result_sucess).into(image_result);
        mWebView.getSettings().setJavaScriptEnabled(true);
        mWebView.getSettings().setSupportZoom(true);
        mWebView.getSettings().setBuiltInZoomControls(true);
        mWebView.getSettings().setCacheMode(WebSettings.LOAD_NO_CACHE);
        mWebView.getSettings().setSupportMultipleWindows(true);
        mWebView.getSettings().setJavaScriptCanOpenWindowsAutomatically(true);
        try_again.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                finish();
            }
        });
        online_call.setOnClickListener(this);
        online_customer.setOnClickListener(this);
        mWebView.setWebChromeClient(new WebChromeClients()
        );
        mWebView.loadUrl("http://kefu253.udesk.cn/im_client/?web_plugin_id=48056");

    }

    private void openImageChooserActivity() {
        //调用自己的图库
        Intent i = new Intent(Intent.ACTION_GET_CONTENT);
        i.addCategory(Intent.CATEGORY_OPENABLE);
        i.setType("image/*");
        startActivityForResult(Intent.createChooser(i, "Image Chooser"), FILE_CHOOSER_RESULT_CODE);
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        if (requestCode == FILE_CHOOSER_RESULT_CODE) { //处理返回的图片，并进行上传
            if (null == uploadMessage && null == uploadMessageAboveL) {
                return;
            }
            Uri result = data == null || resultCode != RESULT_OK ? null : data.getData();
            if (uploadMessageAboveL != null) {
                onActivityResultAboveL(requestCode, resultCode, data);
            } else if (uploadMessage != null) {
                uploadMessage.onReceiveValue(result);
                uploadMessage = null;
            }
        }
    }

    @TargetApi(Build.VERSION_CODES.LOLLIPOP)
    private void onActivityResultAboveL(int requestCode, int resultCode, Intent intent) {
        if (requestCode != FILE_CHOOSER_RESULT_CODE || uploadMessageAboveL == null) {
            return;
        }
        Uri[] results = null;
        if (resultCode == Activity.RESULT_OK) {
            if (intent != null) {
                String dataString = intent.getDataString();
                ClipData clipData = intent.getClipData();
                if (clipData != null) {
                    results = new Uri[clipData.getItemCount()];
                    for (int i = 0; i < clipData.getItemCount(); i++) {
                        ClipData.Item item = clipData.getItemAt(i);
                        results[i] = item.getUri();
                    }
                }
                if (dataString != null) {
                    results = new Uri[]{Uri.parse(dataString)};
                }
            }
        }
        uploadMessageAboveL.onReceiveValue(results);
        uploadMessageAboveL = null;
    }

    private void initEvent() {
        Intent intent = getIntent();
        time = intent.getLongExtra("startTime", 0);
        code = intent.getIntExtra("loginCode", 0);
        result = intent.getStringExtra("loginResult");
        if (code == 1000) {
            try {
                JSONObject jsonObject = new JSONObject(result);
                //应用的appid
                String appId = BuildConfig.APP_ID;
                String token = jsonObject.optString("token");
                Map<String, String> params = new HashMap<String, String>();
                params.put("token", token);
                params.put("appId", appId);
                String sign = SignUtils.getSign(params, BuildConfig.APP_KEY);
                Log.e("logger", "token=" + token);
                getPhone(appId, token, sign);
                displayOperator(token);
            } catch (Exception e) {
                e.printStackTrace();
                errorText.setText("错误日志：" + e.toString());
                authenticationresult_fail.setVisibility(View.VISIBLE);
            }
        } else {
            errorText.setText("状态码：" + code + "\n错误日志：" + result);
            authenticationresult_fail.setVisibility(View.VISIBLE);
        }

    }

    private void displayOperator(String token) {
        if (!TextUtils.isEmpty(token) && token.length() > 2) {
            switch (token.substring(1, 2)) {
                case "3":
                    result_telecom.setVisibility(View.VISIBLE);
                    result_telecom.setText("该能力由中国电信提供");
                    break;
                case "2":
                    result_telecom.setVisibility(View.VISIBLE);
                    result_telecom.setText("该能力由中国联通提供");
                    break;
                case "1":
                    result_telecom.setVisibility(View.VISIBLE);
                    result_telecom.setText("该能力由中国移动提供");
                    break;
                default:
                    result_telecom.setVisibility(View.GONE);
                    break;
            }
        } else {
            result_telecom.setVisibility(View.GONE);
        }
    }

    /**
     * 开发者调用自己的后台接口
     */
    private void getPhone(String appId, String tokenData, String sign) {
        Call<ResponseBody> call = example.getOneKeyLoginMobile(appId, tokenData, sign);
        call.enqueue(new Callback<ResponseBody>() {
            @Override
            public void onResponse(Call<ResponseBody> call, Response<ResponseBody> response) {
                try {
                    String response_data = new String(response.body().bytes());
                    JSONObject json = new JSONObject(response_data);
                    Log.e("fff", "json=" + json.toString());
                    int code = json.optInt("code");
                    if (code == 200000) {
                        JSONObject data = json.getJSONObject("data");
                        String mobileName = data.optString("mobileName");
                        String key = SignUtils.md5(BuildConfig.APP_KEY);
                        String phone = AESUtils.decrypt(mobileName, key.substring(0, 16), key.substring(16));
                        result_phone.setText(phone);
                        result_phone.setVisibility(View.VISIBLE);
                        login_success.setText("登录成功");
                        authenticationresult_success.setVisibility(View.VISIBLE);
                    } else {
                        String msg = json.optString("message");
                        errorText.setText("状态码：" + code + "\n错误日志：" + msg);
                        authenticationresult_success.setVisibility(View.GONE);
                        authenticationresult_fail.setVisibility(View.VISIBLE);

                    }
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }

            @Override
            public void onFailure(Call<ResponseBody> call, Throwable t) {
                errorText.setText("错误日志：" + t.getMessage());
                authenticationresult_success.setVisibility(View.GONE);
                authenticationresult_fail.setVisibility(View.VISIBLE);

            }
        });
    }


    @Override
    public void onClick(View v) {
        switch (v.getId()) {
            case R.id.online_call:
                Intent dialIntent = new Intent();
                dialIntent.setAction(Intent.ACTION_DIAL);
                dialIntent.setData(Uri.parse("tel:400-9669-253"));
                startActivity(dialIntent);
                break;
        }
    }

    public class WebChromeClients extends WebChromeClient {
        // For Android < 3.0
        public void openFileChooser(ValueCallback<Uri> valueCallback) {
            uploadMessage = valueCallback;
            openImageChooserActivity();
        }

        // For Android  >= 3.0
        public void openFileChooser(ValueCallback valueCallback, String acceptType) {
            uploadMessage = valueCallback;
            openImageChooserActivity();
        }

        //For Android  >= 4.1
        public void openFileChooser(ValueCallback<Uri> valueCallback, String acceptType, String capture) {
            uploadMessage = valueCallback;
            openImageChooserActivity();
        }

        // For Android >= 5.0
        @Override
        public boolean onShowFileChooser(WebView webView, ValueCallback<Uri[]> filePathCallback, WebChromeClient.FileChooserParams fileChooserParams) {
            uploadMessageAboveL = filePathCallback;
            openImageChooserActivity();
            return true;
        }
    }
}
