package com.chuanglan.shanyan_sdk_test_demo.view;

import android.Manifest;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.os.Bundle;
import android.support.annotation.NonNull;
import android.support.v4.app.ActivityCompat;
import android.support.v4.content.ContextCompat;
import android.util.Log;

import com.chuanglan.shanyan_sdk.OneKeyLoginManager;
import com.chuanglan.shanyan_sdk.listener.GetPhoneInfoListener;
import com.chuanglan.shanyan_sdk_test_demo.R;

public class SplashActivity extends BaseActivity {
    private int MY_READ_PHONE_STATE = 0;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_splash);
        //申请READ_PHONE_STATE权限
        requestPermission(Manifest.permission.READ_PHONE_STATE);
    }

    private void requestPermission(String permission) {
        if (ContextCompat.checkSelfPermission(this, permission) != PackageManager.PERMISSION_GRANTED) {
            ActivityCompat.requestPermissions(this, new String[]{permission}, MY_READ_PHONE_STATE);
        } else {
            //闪验SDK预取号（可缩短拉起授权页时间）
            OneKeyLoginManager.getInstance().getPhoneInfo(new GetPhoneInfoListener() {
                @Override
                public void getPhoneInfoStatus(int code, String result) {
                    //预取号回调
                    Log.e("VVV", "预取号： code==" + code + "   result==" + result);
                    Intent intent = new Intent(SplashActivity.this, HomeActivity.class);
                    startActivity(intent);
                    finish();
                }
            });
        }
    }

    @Override
    public void onRequestPermissionsResult(int requestCode, @NonNull String[] permissions, @NonNull int[] grantResults) {
        super.onRequestPermissionsResult(requestCode, permissions, grantResults);
        //无论权限是否申请成功，均调用闪验预取号方法
        if (requestCode == MY_READ_PHONE_STATE) {

            //闪验SDK预取号（可缩短拉起授权页时间）
            OneKeyLoginManager.getInstance().getPhoneInfo(new GetPhoneInfoListener() {
                @Override
                public void getPhoneInfoStatus(int code, String result) {
                    //预取号回调
                    Log.e("VVV", "预取号： code==" + code + "   result==" + result);
                    Intent intent = new Intent(SplashActivity.this, HomeActivity.class);
                    startActivity(intent);
                    finish();
                }
            });
        }
    }
}
